﻿Imports System.IO

Public Class Form1

  Dim Pop(80) As Integer ' total female population
  Dim DefaultPop1(80) As Integer
  Dim DefaultPop2(80) As Integer
  Dim DefaultPop3(80) As Integer
  Dim Ngenes(80) As Integer ' total number of mutant genes in the population.
  ' NB each female has 2 genes so Qfactor = Ngenes() / (2 * Pop())
  ' In haploid population each female is also deemed to have two identical genes

  Dim DefaultPopDist() As Integer = {100, 100, 100, 100, 100, 100, 100, 100, 92, 70, 40, 20, 10, 7, 0, 0, 0}
  Dim DefaultBirthRtDist1() As Integer = {0, 0, 0, 0, 100, 100, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
  Dim DefaultDeathRtDist1() As Integer = {0, 0, 0, 0, 0, 0, 0, 12, 30, 55, 110, 155, 190, 215, 230, 240, 250}
  Dim DefaultBirthRtDist2() As Integer = {0, 0, 0, 0, 157, 157, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
  Dim DefaultDeathRtDist2() As Integer = {80, 40, 0, 0, 0, 0, 0, 12, 30, 55, 110, 155, 190, 215, 230, 240, 250}
  Dim DefaultBirthRtDist3() As Integer = {0, 0, 0, 0, 200, 200, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
  Dim DefaultDeathRtDist3() As Integer = {80, 40, 0, 0, 0, 0, 0, 12, 30, 55, 110, 155, 190, 215, 230, 240, 250}

  Dim NormalBirthRt(80) As Integer ' birth rate per 1000
  Dim MutantBirthRt(80) As Integer ' birth rate per 1000
  Dim NormalDeathRt(80) As Integer ' normal death rate per 1000
  Dim MutantDeathRt(80) As Integer ' mutant death rate per 1000

  Dim NormalBirthRtDist(16) As Integer
  Dim MutantBirthRtDist(16) As Integer
  Dim NormalDeathRtDist(16) As Integer
  Dim MutantDeathRtDist(16) As Integer

  Dim pen1 As New Pen(Color.Blue, 2)
  Dim pen2 As New Pen(Color.Red, 2)
  Dim pen7 As New Pen(Color.LawnGreen, 2)
  Dim pen3 As New Pen(Color.Blue, 1)
  Dim pen4 As New Pen(Color.Red, 1)
  Dim pen5 As New Pen(Color.Gray, 1)
  Dim pen6 As New Pen(Color.Gray, 2)

  Dim year As Integer
  Dim TotalPop As Integer
  Dim TotalGenes As Integer
  Dim Font1 As New Font("Ariel", 10)
  Dim Brush1 As New SolidBrush(Color.Black)
  Dim Rand As New Random

  Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
    RadioButton1.Checked = True
    RadioButton4.Checked = True
    RadioButton6.Checked = True
    RadioButton8.Checked = True
    ResetArray(DefaultPop1, DefaultPopDist)
    ResetArray(DefaultPop2, DefaultPopDist)
    ResetArray(DefaultPop3, DefaultPopDist)

    CheckBox2.Checked = True ' limit resources
    ResetDefaultDist3()
    ResetAllRates()
    ResetPop(Pop, DefaultPop3)
    ResetDefaultDist3()
    For i = 1 To 100 : Evolve() : Next
    ResetPop(DefaultPop3, Pop)

    CheckBox2.Checked = False ' unlimit resources
    ResetDefaultDist2()
    ResetAllRates()
    ResetPop(Pop, DefaultPop2)
    ResetDefaultDist2()
    For i = 1 To 100 : Evolve() : Next
    ResetPop(DefaultPop2, Pop)

    ResetDefaultDist1()
    ResetAllRates()
    ResetPop(Pop, DefaultPop1)
    ResetDefaultDist1()
    For i = 1 To 100 : Evolve() : Next
    ResetPop(DefaultPop1, Pop)

    Timer1.Interval = 20
    UpdateNUD1()
    Randomize()
    year = 0
    DisplayInfo()
  End Sub

  Private Sub StartButton(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
    Start()
  End Sub
  Private Sub Start()
    Timer1.Start() : year = 0
    Button1.Enabled = False
    Button2.Enabled = True
  End Sub
  Private Sub StopButton(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
    Finish()
  End Sub
  Private Sub Finish()
    Timer1.Stop()
    Button1.Enabled = True
    Button2.Enabled = False
  End Sub
  Private Sub ResetPopulation(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
    If RadioButton6.Checked Then ResetPop(Pop, DefaultPop1) Else ResetPop(Pop, DefaultPop2)
    For i As Integer = 1 To 80 : Ngenes(i) = 0 : Next
    CalculatePop() : UpdateGraphs()
  End Sub
  Private Sub Evolve(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
    Evolve()
  End Sub
  Private Sub NormaliseBirthRate(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
    For i = 0 To 80
      MutantBirthRt(i) = NormalBirthRt(i)
    Next
    PictureBox1.Invalidate()
  End Sub
  Private Sub NormaliseDeathRate(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
    For i = 0 To 80
      MutantDeathRt(i) = NormalDeathRt(i)
    Next
    PictureBox1.Invalidate()
  End Sub
  Private Sub AddMutant(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
    Ngenes(1) += 1
    CalculatePop() : UpdateGraphs() : year = 0
  End Sub
  Private Sub Add25pcMutant(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
    For i = 1 To 80
      Ngenes(i) += (Pop(i) + 1) \ 2
      If Ngenes(i) > 2 * Pop(i) Then Ngenes(i) = 2 * Pop(i)
    Next
    CalculatePop() : UpdateGraphs() : year = 0
  End Sub
  Private Sub Help(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button9.Click
    If File.Exists("Evolution Help.chm") Then
      Process.Start("Evolution Help.chm")
    Else
      MsgBox("I cannot find a help file")
    End If
  End Sub
  Private Sub ResetAllRates(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button12.Click
    Select Case True
      Case RadioButton6.Checked : ResetDefaultDist1() : ResetPop(Pop, DefaultPop1) : CheckBox2.Checked = False
      Case RadioButton7.Checked : ResetDefaultDist2() : ResetPop(Pop, DefaultPop2) : CheckBox2.Checked = False
      Case Else : ResetDefaultDist3() : ResetPop(Pop, DefaultPop3) : CheckBox2.Checked = True
    End Select
    ResetAllRates() : year = 0
  End Sub
  Private Sub CheckBox2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox2.CheckedChanged
    UpdateNUD1()
  End Sub
  Private Sub UpdateNUD1()
    Label6.Enabled = CheckBox2.Checked
    Label8.Enabled = CheckBox2.Checked
    NumericUpDown1.Enabled = CheckBox2.Checked
  End Sub
  Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick
    Evolve()
  End Sub
  Private Sub RadioButton1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _
  RadioButton1.CheckedChanged, RadioButton2.CheckedChanged
    PictureBox1.Invalidate()
  End Sub
  Private Sub RadioButton8_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton8.CheckedChanged
    Genetype(RadioButton9.Checked)
    UpdateGraphs()
  End Sub
  Private Sub Genetype(ByVal f As Boolean)
    RadioButton3.Enabled = f
    RadioButton4.Enabled = f
    RadioButton5.Enabled = f
  End Sub
  Private Sub PictureBox1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseDown, PictureBox1.MouseMove
    Dim year As Integer = (e.X - 20) \ 5
    If year < 0 Then year = 0
    If year > 80 Then year = 80
    Dim n As Integer = ((275 - e.Y) \ 10) * 10
    If n < 0 Then n = 0
    Select Case True
      Case RadioButton1.Checked
        If e.Button = Windows.Forms.MouseButtons.Left Then NormalBirthRt(year) = n
        If e.Button = Windows.Forms.MouseButtons.Right Then MutantBirthRt(year) = n
      Case RadioButton2.Checked
        If e.Button = Windows.Forms.MouseButtons.Left Then NormalDeathRt(year) = n
        If e.Button = Windows.Forms.MouseButtons.Right Then MutantDeathRt(year) = n
    End Select
    PictureBox1.Invalidate()
  End Sub
  Private Sub PictureBox2_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox2.MouseDown, PictureBox2.MouseMove
    Dim year As Integer = (e.X - 20) \ 5
    If year < 0 Then year = 0
    If year > 80 Then year = 80
    Dim n As Integer = 270 - e.Y
    If n < 0 Then n = 0
    Select Case e.Button
      Case Windows.Forms.MouseButtons.Left
        Pop(year) = n
        If Pop(year) < 0 Then Pop(year) = 0
        If Ngenes(year) > Pop(year) Then Ngenes(year) = Pop(year)
      Case Windows.Forms.MouseButtons.Right
        If n > Pop(year) Then n = Pop(year)
        If n < 0 Then n = 0
        If Pop(year) > 0 Then Ngenes(year) = 2 * n Else Ngenes(year) = 0
    End Select
    CalculatePop() : UpdateGraphs()
  End Sub
  Private Sub PictureBox1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PictureBox1.Paint
    With e.Graphics
      .TranslateTransform(25, 270)
      .DrawLine(Pens.Black, 0, 0, 0, -250)
      .DrawLine(Pens.Black, 0, 0, 400, 0)
      .DrawString("0", Font1, Brush1, -15, 0)
      For i As Integer = 1 To 8
        .DrawLine(Pens.LightGray, 50 * i, 0, 50 * i, -250)
        .DrawString(Format(i * 10), Font1, Brush1, 50 * i - 10, 0)
      Next
      For i As Integer = 1 To 5
        .DrawLine(Pens.LightGray, 0, -50 * i, 400, -50 * i)
        If i < 2 Then
          .DrawString(Format(5 * i), Font1, Brush1, -11, -50 * i - 10)
        Else
          .DrawString(Format(5 * i), Font1, Brush1, -18, -50 * i - 10)
        End If
      Next
      Dim j As Integer
      Dim NBR As Integer = 0
      Dim MBR As Integer = 0
      Dim NSR As Double = 1
      Dim MSR As Double = 1
      For i As Integer = 1 To 80
        NBR += NormalBirthRt(i)
        MBR += MutantBirthRt(i)
        If i < 16 Then
          NSR = NSR * (1 - NormalDeathRt(i) / 1000)
          MSR = MSR * (1 - MutantDeathRt(i) / 1000)
        End If
        j = 5 * i - 5
        Select Case True
          Case RadioButton1.Checked
            .DrawLine(pen1, j, 0, j, -NormalBirthRt(i))
            .DrawLine(pen2, j + 2, 0, j + 2, -MutantBirthRt(i))
            .DrawString("Birth rate % per year per female", Font1, Brush1, 160, -270)
          Case RadioButton2.Checked
            .DrawLine(pen1, j, 0, j, -NormalDeathRt(i))
            .DrawLine(pen2, j + 2, 0, j + 2, -MutantDeathRt(i))
            .DrawString("Death rate % per year", Font1, Brush1, 160, -270)
        End Select
      Next
      Select Case True
        Case RadioButton1.Checked
          .DrawString("Birth rate % per year per female", Font1, Brush1, 160, -270)
          .DrawString("Normal birth rate " & Format(NBR \ 10) & "%", Font1, Brush1, 260, -240)
          .DrawString("Mutant birth rate " & Format(MBR \ 10) & "%", Font1, Brush1, 260, -224)
        Case RadioButton2.Checked
          .DrawString("Death rate % per year", Font1, Brush1, 160, -270)
          .DrawString("Normal survival rate " & Number(100 * NSR) & "%", Font1, Brush1, 20, -240)
          .DrawString("Mutant survival rate " & Number(100 * MSR) & "%", Font1, Brush1, 20, -224)
      End Select

      .DrawString("k = " & Format(NSR * NBR / 1000, "0.00"), Font1, Brush1, 180, -240)
      .DrawString("k = " & Format(MSR * MBR / 1000, "0.00"), Font1, Brush1, 180, -224)
    End With
  End Sub
  Private Sub PictureBox2_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PictureBox2.Paint
    With e.Graphics
      .TranslateTransform(25, 270)
      .DrawLine(Pens.Black, 0, 0, 0, -250)
      .DrawLine(Pens.Black, 0, 0, 400, 0)
      .DrawString("0", Font1, Brush1, -15, 0)
      .DrawString("Female population per year", Font1, Brush1, 160, -270)
      For i As Integer = 1 To 8
        .DrawLine(Pens.LightGray, 50 * i, 0, 50 * i, -250)
        .DrawString(Format(i * 10), Font1, Brush1, 50 * i - 10, 0)
      Next
      For i As Integer = 1 To 6
        .DrawLine(Pens.LightGray, 0, -50 * i, 400, -50 * i)
        If i < 2 Then
          .DrawString(Format(50 * i), Font1, Brush1, -18, -50 * i - 10)
        Else
          .DrawString(Format(50 * i), Font1, Brush1, -25, -50 * i - 10)
        End If
      Next
      Dim j As Integer
      Dim q As Double
      For i As Integer = 1 To 80
        j = 5 * i - 5
        If Pop(i) = 0 Then
          Ngenes(i) = 0 : q = 0
        Else
          q = Ngenes(i) / (2 * Pop(i))
        End If
        If RadioButton9.Checked Then
          .DrawLine(pen1, j, 0, j, -Pop(i))
          .DrawLine(pen7, j, 0, j, -CInt(Pop(i) * q * (2 - q)))
          .DrawLine(pen2, j, 0, j, -CInt(Pop(i) * q * q))
        Else
          .DrawLine(pen1, j, 0, j, -Pop(i))
          .DrawLine(pen2, j, 0, j, -CInt(Pop(i) * q))
        End If
      Next
    End With
  End Sub
  Private Sub DisplayInfo()
    Label1.Text = "Year: " & Str(year)
    Label2.Text = "Generation:" & Str(year \ 22.5)
    Label3.Text = "Female population: " & Number(TotalPop)
    If TotalPop > 0 Then
      If RadioButton8.Checked Then
        Label4.Text = "Number of mutant alleles: " & Number(TotalGenes \ 2)
      Else
        Label4.Text = "Number of mutant alleles: " & Number(TotalGenes)
      End If
      Label5.Text = " or    " & Number(100 * TotalGenes / (2 * TotalPop)) & "%"
    Else
      Label4.Text = ""
      Label5.Text = ""
    End If
  End Sub
  Private Function Number(ByVal n As Integer) As String
    Select Case True
      Case n > 99999 : Return Format(n / 1000000, "f") & " M"
      Case n > 19999 : Return Format(n / 1000, "f") & " k"
    End Select
    Return Format(n)
  End Function
  Private Sub ResetDefaultDist1()
    For i As Integer = 0 To 16
      NormalBirthRtDist(i) = DefaultBirthRtDist1(i)
      MutantBirthRtDist(i) = DefaultBirthRtDist1(i)
      NormalDeathRtDist(i) = DefaultDeathRtDist1(i)
      MutantDeathRtDist(i) = DefaultDeathRtDist1(i)
    Next
  End Sub
  Private Sub ResetDefaultDist2()
    For i As Integer = 0 To 16
      NormalBirthRtDist(i) = DefaultBirthRtDist2(i)
      MutantBirthRtDist(i) = DefaultBirthRtDist2(i)
      NormalDeathRtDist(i) = DefaultDeathRtDist2(i)
      MutantDeathRtDist(i) = DefaultDeathRtDist2(i)
    Next
  End Sub
  Private Sub ResetDefaultDist3()
    For i As Integer = 0 To 16
      NormalBirthRtDist(i) = DefaultBirthRtDist3(i)
      MutantBirthRtDist(i) = DefaultBirthRtDist3(i)
      NormalDeathRtDist(i) = DefaultDeathRtDist3(i)
      MutantDeathRtDist(i) = DefaultDeathRtDist3(i)
    Next
  End Sub
  Private Sub ResetAllRates()
    For i As Integer = 1 To 80 : Ngenes(i) = 0 : Next
    ResetArray(NormalBirthRt, NormalBirthRtDist)
    ResetArray(MutantBirthRt, MutantBirthRtDist)
    ResetArray(NormalDeathRt, NormalDeathRtDist)
    ResetArray(MutantDeathRt, MutantDeathRtDist)
    CalculatePop() : UpdateGraphs()
  End Sub
  Private Sub ResetArray(ByRef a, ByVal b)
    ' Sets the 80 members of a() to distribution b() interpolating in quintades
    For i = 0 To 15
      For j = 0 To 4
        a(5 * i + j + 1) = b(i) + j * (b(i + 1) - b(i)) / 5
      Next
    Next
  End Sub
  Private Sub ResetPop(ByRef a, ByVal b)
    ' Sets the 80 members of a() to b()
    For i = 1 To 80
      a(i) = b(i)
    Next
  End Sub

  Private Sub CalculatePop()
    TotalPop = 0 : TotalGenes = 0
    For i As Integer = 1 To 80
      TotalPop += Pop(i)
      TotalGenes += Ngenes(i)
    Next
  End Sub
  Private Sub UpdateGraphs()
    PictureBox1.Invalidate()
    PictureBox2.Invalidate()
    DisplayInfo()
  End Sub

  Private Sub Evolve()
    Dim nbabies As Integer = 0
    Dim nbgenes As Integer = 0
    Dim ndeaths As Double
    Dim ndgenes As Double
    Dim q As Double
    Dim ap, bp, cp As Double ' ap is normal homozygous, bp is hterozygous, cp is mutant homozygous
    Dim an, bn, b2n, cn As Double ' temporary variables
    For i As Integer = 79 To 1 Step -1
      'If i = 20 Then Stop
      ndeaths = 0 : ndgenes = 0
      If Pop(i) = 0 Then
        q = 0
      Else
        q = Ngenes(i) / (2 * Pop(i))
      End If
      If RadioButton8.Checked Then 'haploid
        ap = Pop(i) * (1 - q)
        cp = Pop(i) * q
        an = AverageInteger(ap * NormalBirthRt(i) / 1000)
        cn = AverageInteger(cp * MutantBirthRt(i) / 1000)
        nbabies += an + cn
        nbgenes += 2 * cn
        an = ap * DeathRate(NormalDeathRt(i)) / 1000
        cn = cp * DeathRate(MutantDeathRt(i)) / 1000
        ndeaths += an + cn
        ndgenes += 2 * cn
      Else 'diploid
        ap = Pop(i) * (1 - q) ^ 2
        bp = Pop(i) * 2 * (1 - q) * q
        cp = Pop(i) * q ^ 2
        Select Case True
          Case RadioButton3.Checked ' dominant
            an = AverageInteger(ap * NormalBirthRt(i) / 1000)
            bn = AverageInteger(bp * MutantBirthRt(i) / 1000)
            cn = AverageInteger(cp * MutantBirthRt(i) / 1000)
            nbabies += an + bn + cn
            nbgenes += bn + 2 * cn
            an = ap * DeathRate(NormalDeathRt(i)) / 1000
            bn = bp * DeathRate(MutantDeathRt(i)) / 1000
            cn = cp * DeathRate(MutantDeathRt(i)) / 1000
            ndeaths += an + bn + cn
            ndgenes += bn + 2 * cn
          Case RadioButton4.Checked ' neutral
            an = AverageInteger(ap * NormalBirthRt(i) / 1000)
            bn = AverageInteger(bp / 2 * NormalBirthRt(i) / 1000)
            b2n = AverageInteger(bp / 2 * MutantBirthRt(i) / 1000)
            cn = AverageInteger(cp * MutantBirthRt(i) / 1000)
            nbabies += an + bn + b2n + cn
            nbgenes += bn + b2n + 2 * cn
            an = ap * DeathRate(NormalDeathRt(i)) / 1000
            bn = bp / 2 * DeathRate(NormalDeathRt(i)) / 1000
            b2n = bp / 2 * DeathRate(MutantDeathRt(i)) / 1000
            cn = cp * DeathRate(MutantDeathRt(i)) / 1000
            ndeaths += an + bn + b2n + cn
            ndgenes += bn + b2n + 2 * cn
          Case RadioButton5.Checked ' recessive
            an = AverageInteger(ap * NormalBirthRt(i) / 1000)
            bn = AverageInteger(bp * NormalBirthRt(i) / 1000)
            cn = AverageInteger(cp * MutantBirthRt(i) / 1000)
            nbabies += an + bn + cn
            nbgenes += bn + 2 * cn
            an = ap * DeathRate(NormalDeathRt(i)) / 1000
            bn = bp * DeathRate(NormalDeathRt(i)) / 1000
            cn = cp * DeathRate(MutantDeathRt(i)) / 1000
            ndeaths += an + bn + cn
            ndgenes += bn + 2 * cn
        End Select
      End If
      Pop(i + 1) = AverageInteger(Pop(i) - ndeaths)
      Ngenes(i + 1) = AverageInteger(Ngenes(i) - ndgenes)
      If Ngenes(i + 1) > 2 * Pop(i + 1) Then Ngenes(i + 1) = 2 * Pop(i + 1)
    Next
    Pop(1) = nbabies
    Ngenes(1) = nbgenes
    If Ngenes(1) > 2 * Pop(1) Then Ngenes(1) = 2 * Pop(1)
    year += 1
    CalculatePop() : UpdateGraphs()
    If CheckBox1.Checked And TotalGenes > TotalPop Then Finish()
    If TotalPop > 1000000 Then Finish()
  End Sub
  Private Function AverageInteger(ByVal p As Double) As Integer
    ' return an integer whose average value over many instances is equal to p
    ' eg if p = 3.735
    If p = 0 Then Return 0
    Dim n As Integer = Int(p) ' Int returns integer part
    ' n = 3
    Dim m As Integer = CInt((p - n) * 1000) ' CInt returns nearest integer
    ' m = 735
    If m = 0 Then
      ' p is an almost exact integer
      If n > 1 Then
        ' return integer above or below 50% of the time
        Dim r As Integer = Rand.Next(4)
        Select Case r
          Case 0 : n -= 1
          Case 3 : n += 1
        End Select
      End If
    Else
      ' return integer above on occasion in proportion
      Dim r As Integer = Rand.Next(1000)
      ' r is a random number between 0 and 999 - eg 392
      If r < m Then n += 1
      ' since 392<735, in this instance we add 1 to n so n=4
    End If
    Return n
  End Function
  Private Function DeathRate(ByVal dr)
    ' dr is an integer between 0 and 1000
    If CheckBox2.Checked = False Then Return dr
    Dim Poplimit As Integer = NumericUpDown1.Value * 1000
    If TotalPop > Poplimit Then
      Dim excess As Double = TotalPop / Poplimit - 1
      ' increase death rate in quadratic proportion
      dr += dr * dr * excess / 20
      ' increase death rate in proportion
      ' dr += dr * excess
      ' increase death rate across the board
      dr += 40 * excess
      If dr > 1000 Then dr = 1000
    End If
    Return dr
  End Function

  Private Function Survival(ByVal p)
    ' given that the total mutant birth rate is p (p>1)
    ' this function return the probability of survival of a single mutation
    Dim n As Integer ' number of mutant genes
    Dim s As Integer = 0 ' number of successes
    Dim r As Integer
    For g As Integer = 1 To 100
      n = 1
      For i As Integer = 1 To 1000
        n = AverageInteger(n * p)
        r = Rand.Next(3)
        Select Case r
          Case 0 : n -= 1
          Case 2 : n += 1
        End Select
        If n = 0 Then Exit For
        If n > 100 Then s += 1 : Exit For
      Next
    Next
    Return s

  End Function

  Private Sub Button11_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    For p As Double = 1 To 1.5 Step 0.02
      Debug.Print(Str(Survival(p)))
    Next
  End Sub

End Class
